#include "AnyMatcher.h"
#include <Engine/SearchEngine.h>

int AnyMatcher::match(const Vector<tTerm>& queryTerms, Set<tMatchResult>& result)
{
	result.clear();

	UINT matchedDocs = 0;

	for (int i = 0; i < queryTerms.size(); i++) {
		tTerm term = queryTerms[i];
		// retrieve the documents that correspond to this token
		const tRow* row = SearchEngine::instance().getTermDocuments(term);
		if (row != NULL) {
			// search in which document the token has appeared
			for (tRow::const_iterator iDocs = row->begin() ; iDocs != row->end() ; iDocs++ ) {
				tDocID docID = iDocs->first;
				// Update the tMatchResult for this term
				Set<tMatchResult>::iterator iMatchedDoc = result.find(tMatchResult(docID));
				if (iMatchedDoc != result.end()) {
				  tMatchResult temp = *iMatchedDoc;
				  temp.matchScore++;
				  result.erase(iMatchedDoc);
				  result.insert(temp);
				} else {
					if (matchedDocs < m_maxToMatch)
						result.insert(tMatchResult(docID));
					matchedDocs++;
				}
			}
		}
	}
	return matchedDocs;
}
