#include "StopWordTokenizer.h"

void StopWordTokenizer::readStopWordFile(const std::string& filename)
{
	// make sure the set is clean
	m_stopWordsSet.clear();
	
	WordTokenizer wordTokenizer;
	std::ifstream s(filename.c_str());
	if (!s.is_open()) {
		THROW("Failed opening stopword file " + filename);
	}
	wordTokenizer.setInput(s);
	tTerm stopWord;
	while (wordTokenizer.getNextTerm(stopWord)) {
		if (stopWord.size() > 0)
			m_stopWordsSet.insert(stopWord);
	}
}

bool StopWordTokenizer::isStopWord(tTerm Term)
{
	return (m_stopWordsSet.find(Term) != m_stopWordsSet.end());
}

bool StopWordTokenizer::getNextTerm(tTerm& term)
{
	tTerm s;
	while (WordTokenizer::getNextTerm(s)) {
		if (!isStopWord(s)) {
			term = s;
			return true;
		}
	}
	return false;
};