// StopWordTokenizer.h: interface for the WordTokenizer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _STOP_WORD_TOKENIZER_H_ 
#define _STOP_WORD_TOKENIZER_H_ 

#define DEFAULT_STOPWORDS_FILENAME "stopwords.txt"
#include "WordTokenizer.h"

class StopWordTokenizer : public WordTokenizer
{
private:
	Set<tTerm> m_stopWordsSet;
public:
	// constructor
	StopWordTokenizer(const std::string& stopwordsFilename = DEFAULT_STOPWORDS_FILENAME) {
		readStopWordFile(stopwordsFilename);
	}

	/**
	 * Return the next token from the input.
	 * The input is a string and a token is a word
	 */
	virtual bool getNextTerm(tTerm& term);
protected:
	/**
	 * Returns true if there are more token(s) in the stream ,
	 * false otherwise
	 */
	void readStopWordFile(const std::string& filename);
	/**
	 * Returns true if the Term is a stop word, false otherwise
	 */
	bool isStopWord(tTerm Term);
};

#endif // _STOP_WORD_TOKENIZER_H_ 
