#include "WordTokenizer.h"
#include <algorithm>
#include <algorithm>
#include <cctype>      

// These are the accepted symbols,
// all other non-alphanumeric chars are
// considered as whitespace
#define ACCEPTED_SYMBOLS "'`_$%"

bool hasAlpha(tTerm& term) {
	for (int i = 0; i < term.size(); i++)
		if (isalpha(term[i]))
			return true;
	return false;
}

bool WordTokenizer::getNextTerm(tTerm& term)
{
	tTerm s;
	// Clear whitespace
	(*m_stream) >> std::ws;
	char ch;
	/* We decided that it's better not to support "" phrases
	ch = m_stream->peek();
	if (ch == '"') {
		m_stream->get(); // clear leading '"'
		while ( ((ch = m_stream->get()) != '"') && (ch != '\n') && m_stream->good()) {
			s += ch;
		}
		m_stream->get(); // clear trainling '"' (if exists)
	} else */{
		do {
			do {
				ch = m_stream->get();
				if ((!isspace(ch)) && (isalnum(ch) || strchr(ACCEPTED_SYMBOLS, ch)))
					s += ch;
				else
					break;
			} while (m_stream->good());
			// Dont save words with not letters
			if (!hasAlpha(s))
				s = "";
			// Clear ACCEPTED_SYMBOLS prefix & suffix
			while ((s.size() > 0) && strchr(ACCEPTED_SYMBOLS, s[0]))
				s.erase(s.begin());
			while ((s.size() > 0) && strchr(ACCEPTED_SYMBOLS, s[s.size()-1]))
				s.erase(s.begin()+s.size()-1);
		} while (m_stream->good() && (s.size() == 0));
	}
	if ((!m_stream->good()) && (s.size() == 0))
		return false;
	(*m_stream) >> std::ws;
	// Convert s to lower case
	std::transform(s.begin(), s.end(), s.begin(), tolower);
	term = s;
	return true;
};